<template>
  <div>
    <div class="flex items-center justify-between mb-8">
      <t-span weight="bold">Nearby</t-span>
      <t-span weight="bold">{{ total }} total</t-span>
    </div>
    <template v-if="isNearbyCompletedStatus">
    <a-table :columns="columns" :data-source="nearby" size="middle" :loading="isNearbyFetching" :total="total" :pagination="false">
      <a slot="facePreview" slot-scope="id, row">
        <img :src="row.facePreview" />
      </a>
      <div slot="nearByDate" slot-scope="id, row">
        {{ getDate(row.nearByDate) }}
      </div>
      <div slot="startTime" slot-scope="id, row">
        {{ getTime(row.startTime) }}
      </div>
      <div slot="endTime" slot-scope="id, row">
        {{ getTime(row.endTime) }}
      </div>
      <div slot="video" slot-scope="id, row" class="flex items-center justify-center">
        <person-video-dialog :passenger-id="row.globalId" :camera-id="row.cameraId" :start-time="row.startTime" :end-time="row.endTime">
          <b-outline-action-button>
            <a-icon type="video-camera" class="text-2xl leading-none text-blue-default" />
          </b-outline-action-button>
        </person-video-dialog>
      </div>
    </a-table>
    <div v-if="nearby.length > 0" class="mt-4 text-right">
      <a-pagination v-model="pagination.page" size="small" :page-size="pagination.limit" :total="total" show-less-items @change="onPaginate" />
    </div>
    </template>
    <template v-else>
      <div class="flex flex-col items-center justify-center space-y-2">
        <a-spin></a-spin>
        <t-span>The system is currently processing...</t-span>
      </div>
    </template>
  </div>
</template>

<script>
import moment from 'moment'
import { defineComponent } from '@nuxtjs/composition-api'
import TSpan from '~/components/shared/typography/Span'
import { useBuilding } from '~/store/building'
import useNearbyPerson from '~/composables/useNearbyPerson'
import PersonVideoDialog from '~/components/video/PersonVideoDialog.vue'
import BOutlineActionButton from '~/components/shared/buttons/OutlineActionButton.vue'

const columns = [
  {
    title: 'FACE PREVIEW',
    dataIndex: 'facePreview',
    key: 'facePreview',
    scopedSlots: { customRender: 'facePreview' },
    width: 120,
  },
  {
    title: 'Name',
    dataIndex: 'displayName',
    key: 'displayName',
  },
  {
    title: 'AREA',
    dataIndex: 'areaName',
    key: 'areaName',
  },
  {
    title: 'UNIT',
    dataIndex: 'unitName',
    key: 'unitName',
  },
  {
    title: 'NEAR BY DATE',
    dataIndex: 'nearByDate',
    scopedSlots: { customRender: 'nearByDate' },
    key: 'nearByDate',
  },
  {
    title: 'START TIME',
    dataIndex: 'startTime',
    scopedSlots: { customRender: 'startTime' },
    key: 'startTime',
  },
  {
    title: 'END TIME',
    dataIndex: 'endTime',
    scopedSlots: { customRender: 'endTime' },
    key: 'endTime',
  },
  {
    title: 'VIDEO',
    dataIndex: '#',
    scopedSlots: { customRender: 'video' },
    key: 'video',
  },
]

export default defineComponent({
  components: { TSpan, PersonVideoDialog, BOutlineActionButton },
  setup() {
    const store = useBuilding()
    return { store, ...useNearbyPerson() }
  },
  data() {
    return {
      columns,
      pagination: {
        page: 1,
        limit: 10,
      },
      watcher: null,
    }
  },
  watch: {
    status() {
      if (this.isNearbyProcessingStatus) {
        this.watcher = setInterval(this.fetch, 5000)
      }

      if (this.isNearbyCompletedStatus) {
        clearInterval(this.watcher)
      }
    },
  },
  mounted() {
    this.fetch()
  },
  methods: {
    fetch() {
      const startTime = `${this.store.currentDate} ${this.store.currentStartTime}`
      const endTime = `${this.store.currentDate} ${this.store.currentEndTime}`

      this.fetchNearby(
        this.store.buildingId,
        startTime,
        endTime,
        this.store.selectedPassengerId,
        this.pagination.page,
        this.pagination.limit
      )
    },
    onPaginate(page, limit) {
      const startTime = `${this.store.currentDate} ${this.store.currentStartTime}`
      const endTime = `${this.store.currentDate} ${this.store.currentEndTime}`

      this.fetchNearby(
        this.store.buildingId,
        startTime,
        endTime,
        this.store.selectedPassengerId,
        page,
        limit
      )
    },
    getDate(isoDate) {
      return moment(isoDate).format('yyyy-MM-DD')
    },
    getTime(isoDate) {
      return moment(isoDate).format('HH.mm.SS.SSS')
    },
  },
})
</script>
